diff --git a/ChangeLog b/ChangeLog
index ce4471e..e2954e5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,22 @@
 2016-06-28  Adhemerval Zanella  <adhemerval.zanella@linaro.org>
 
+	* sysdeps/unix/sysv/linux/fallocate.c (fallocate): Use SYSCALL_LL
+	macro on offset argument.
+	* sysdeps/unix/sysv/linux/fallocate64.c (fallocate64): Use
+	SYSCALL_LL64 on offset argument.
+	* sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate.c: Remove file.
+	* sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate64.c: Likewise.
+	* sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate.c: Likewise.
+	* sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate64.c: Likewise.
+	* sysdeps/unix/sysv/linux/wordsize-64/fallocate.c: Likewise.
+	* sysdeps/unix/sysv/linux/wordsize-64/fallocate64.c: Likewise.
+	* sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list (fallocate): Remove
+	syscall auto-generation.
+	* sysdeps/unix/sysv/linux/Makefile (test): Add tst-fallocate and
+	tst-fallocate64.
+	* sysdeps/unix/sysv/linux/tst-fallocate.c: New file.
+	* sysdeps/unix/sysv/linux/tst-fallocate64.c: Likewise.
+
 	* sysdeps/unix/sysv/linux/mips/kernel-features.h
 	(__ASSUME_OFF_DIFF_OFF64): Remove define.
 	* sysdeps/unix/sysv/linux/pread.c
diff --git a/sysdeps/unix/sysv/linux/Makefile b/sysdeps/unix/sysv/linux/Makefile
index 35e1ed4..d966a5f 100644
--- a/sysdeps/unix/sysv/linux/Makefile
+++ b/sysdeps/unix/sysv/linux/Makefile
@@ -42,7 +42,8 @@ sysdep_headers += sys/mount.h sys/acct.h sys/sysctl.h \
 		  bits/socket_type.h bits/syscall.h bits/sysctl.h \
 		  bits/mman-linux.h
 
-tests += tst-clone tst-clone2 tst-fanotify tst-personality
+tests += tst-clone tst-clone2 tst-fanotify tst-personality tst-fallocate \
+	 tst-fallocate64
 
 # Generate the list of SYS_* macros for the system calls (__NR_* macros).
 
diff --git a/sysdeps/unix/sysv/linux/fallocate.c b/sysdeps/unix/sysv/linux/fallocate.c
index 6a58a5f..a38e9a6 100644
--- a/sysdeps/unix/sysv/linux/fallocate.c
+++ b/sysdeps/unix/sysv/linux/fallocate.c
@@ -19,17 +19,12 @@
 #include <fcntl.h>
 #include <sysdep-cancel.h>
 
-
+#ifndef __OFF_T_MATCHES_OFF64_T
 /* Reserve storage for the data of the file associated with FD.  */
 int
 fallocate (int fd, int mode, __off_t offset, __off_t len)
 {
-#ifdef __NR_fallocate
   return SYSCALL_CANCEL (fallocate, fd, mode,
-			 __LONG_LONG_PAIR (offset >> 31, offset),
-			 __LONG_LONG_PAIR (len >> 31, len));
-#else
-  __set_errno (ENOSYS);
-  return -1;
-#endif
+			 SYSCALL_LL (offset), SYSCALL_LL (len));
 }
+#endif
diff --git a/sysdeps/unix/sysv/linux/fallocate64.c b/sysdeps/unix/sysv/linux/fallocate64.c
index 8e76d6f..d466095 100644
--- a/sysdeps/unix/sysv/linux/fallocate64.c
+++ b/sysdeps/unix/sysv/linux/fallocate64.c
@@ -24,14 +24,10 @@
 int
 fallocate64 (int fd, int mode, __off64_t offset, __off64_t len)
 {
-#ifdef __NR_fallocate
   return SYSCALL_CANCEL (fallocate, fd, mode,
-			 __LONG_LONG_PAIR ((long int) (offset >> 32),
-					   (long int) offset),
-			 __LONG_LONG_PAIR ((long int) (len >> 32),
-					   (long int) len));
-#else
-  __set_errno (ENOSYS);
-  return -1;
-#endif
+			 SYSCALL_LL64 (offset), SYSCALL_LL64 (len));
 }
+
+#ifdef __OFF_T_MATCHES_OFF64_T
+weak_alias (fallocate64, fallocate)
+#endif
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate.c b/sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate.c
deleted file mode 100644
index 4e432f4..0000000
--- a/sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate.c
+++ /dev/null
@@ -1,33 +0,0 @@
-/* Copyright (C) 2007-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <fcntl.h>
-#include <sysdep-cancel.h>
-
-
-/* Reserve storage for the data of the file associated with FD.  */
-int
-fallocate (int fd, int mode, __off_t offset, __off_t len)
-{
-#ifdef __NR_fallocate
-  return SYSCALL_CANCEL (fallocate, fd, mode, offset, len);
-#else
-  __set_errno (ENOSYS);
-  return -1;
-#endif
-}
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate64.c b/sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate64.c
deleted file mode 100644
index 95c9eab..0000000
--- a/sysdeps/unix/sysv/linux/mips/mips64/n32/fallocate64.c
+++ /dev/null
@@ -1,33 +0,0 @@
-/* Copyright (C) 2007-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <fcntl.h>
-#include <sysdep-cancel.h>
-
-
-/* Reserve storage for the data of the file associated with FD.  */
-int
-fallocate64 (int fd, int mode, __off64_t offset, __off64_t len)
-{
-#ifdef __NR_fallocate
-  return SYSCALL_CANCEL (fallocate, fd, mode, offset, len);
-#else
-  __set_errno (ENOSYS);
-  return -1;
-#endif
-}
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate.c b/sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate.c
deleted file mode 100644
index d3b7218..0000000
--- a/sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/unix/sysv/linux/wordsize-64/fallocate.c>
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate64.c b/sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate64.c
deleted file mode 100644
index fb2b681..0000000
--- a/sysdeps/unix/sysv/linux/mips/mips64/n64/fallocate64.c
+++ /dev/null
@@ -1 +0,0 @@
-/* fallocate64 is in fallocate.c */
diff --git a/sysdeps/unix/sysv/linux/tst-fallocate.c b/sysdeps/unix/sysv/linux/tst-fallocate.c
new file mode 100644
index 0000000..f1718e0
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/tst-fallocate.c
@@ -0,0 +1,117 @@
+/* Basic fallocate test (no specific flags is checked).
+   Copyright (C) 2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <fcntl.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+/* Allow testing of the 64-bit versions as well.  */
+#ifndef FALLOCATE
+# define FALLOCATE fallocate
+#endif
+
+static void do_prepare (void);
+static int do_test (void);
+#define PREPARE(argc, argv)     do_prepare ()
+#define TEST_FUNCTION           do_test ()
+#include "../test-skeleton.c"
+
+static char *temp_filename;
+static int temp_fd;
+
+void
+do_prepare (void)
+{
+  temp_fd = create_temp_file ("tst-fallocate.", &temp_filename);
+  if (temp_fd == -1)
+    {
+      printf ("cannot create temporary file: %m\n");
+      exit (1);
+    }
+}
+
+#define FAIL(str) \
+  do { printf ("error: %s (line %d)\n", str, __LINE__); return 1; } while (0)
+
+int
+do_test (void)
+{
+  int ret;
+  struct stat finfo;
+  char buffer[1024] = { 0xf0 };
+  char buf2read[1024];
+
+  /* It tries to fallocate 1024 bytes from offset 0 and then write 1024 bytes.
+     After both operation rewind the file descriptor and read 1024 bytes
+     and check if both buffer have the same contents.  */
+  ret = FALLOCATE (temp_fd, 0, 0, 1024);
+  if (ret == -1)
+    FAIL ("fallocate failed");
+
+  ret = fstat (temp_fd, &finfo);
+  if (ret == -1)
+    FAIL ("fstat failed");
+
+  if (finfo.st_size < 1024)
+    FAIL ("size of first fallocate less than expected (1024)");
+
+  if (lseek (temp_fd, 0, SEEK_SET) == (off_t) -1)
+    FAIL ("fseek (0, SEEK_SET) failed");
+
+  if (write (temp_fd, buffer, 1024) != 1024)
+    FAIL ("fail trying to write 1024 bytes");
+
+  if (lseek (temp_fd, 0, SEEK_SET) == (off_t) -1)
+    FAIL ("fseek (0, SEEK_SET) failed");
+
+  if (read (temp_fd, buf2read, 1024) != 1024)
+    FAIL ("fail trying to read 1024 bytes");
+
+  if (memcmp (buffer, buf2read, 1024) != 0)
+    FAIL ("buffer writted different than buffer readed");
+
+  /* It issues the same test as before but using a 1024 bytes offset.  */
+  ret = FALLOCATE (temp_fd, 0, 1024, 2048);
+  if (ret == -1)
+    FAIL ("fallocate failed");
+
+  ret = fstat (temp_fd, &finfo);
+  if (ret == -1)
+    FAIL ("fstat failed");
+
+  if (finfo.st_size < (1024 + 2048))
+    FAIL ("size of second fallocate less than expected (1024 + 2048)");
+
+  if (lseek (temp_fd, 2048, SEEK_SET) == (off_t) -1)
+    FAIL ("fseek (2048, SEEK_SET) failed");
+
+  if (write (temp_fd, buffer, 1024) != 1024)
+    FAIL ("fail trying to write 1024 bytes");
+
+  if (lseek (temp_fd, 2048, SEEK_SET) == (off_t) -1)
+    FAIL ("fseek (2048, SEEK_SET) failed");
+
+  if (read (temp_fd, buf2read, 1024) != 1024)
+    FAIL ("fail trying to read 1024 bytes");
+
+  if (memcmp (buffer, buf2read, 1024) != 0)
+    FAIL ("buffer writted different than buffer readed");
+
+  return 0;
+}
diff --git a/sysdeps/unix/sysv/linux/tst-fallocate64.c b/sysdeps/unix/sysv/linux/tst-fallocate64.c
new file mode 100644
index 0000000..649f653
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/tst-fallocate64.c
@@ -0,0 +1,21 @@
+/* Basic fallocate64 test (no specific flags is checked).
+   Copyright (C) 2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#define FALLOCATE fallocate64
+
+#include "tst-fallocate.c"
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/fallocate.c b/sysdeps/unix/sysv/linux/wordsize-64/fallocate.c
deleted file mode 100644
index c1dd0b4..0000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/fallocate.c
+++ /dev/null
@@ -1,34 +0,0 @@
-/* Copyright (C) 2007-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <fcntl.h>
-#include <sysdep-cancel.h>
-
-
-/* Reserve storage for the data of the file associated with FD.  */
-int
-fallocate (int fd, int mode, __off_t offset, __off_t len)
-{
-#ifdef __NR_fallocate
-  return SYSCALL_CANCEL (fallocate, fd, mode, offset, len);
-#else
-  __set_errno (ENOSYS);
-  return -1;
-#endif
-}
-strong_alias (fallocate, fallocate64)
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/fallocate64.c b/sysdeps/unix/sysv/linux/wordsize-64/fallocate64.c
deleted file mode 100644
index df33112..0000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/fallocate64.c
+++ /dev/null
@@ -1 +0,0 @@
-/* fallocate64 is in posix_fallocate.c */
diff --git a/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list b/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list
index dce4302..8cccb1d 100644
--- a/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list
+++ b/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list
@@ -1,6 +1,5 @@
 # File name	Caller	Syscall name	# args	Strong name	Weak names
 
-fallocate	-	fallocate	Ci:iiii	fallocate	fallocate64
 gettimeofday	-	gettimeofday:__vdso_gettimeofday@LINUX_2.6	i:pP	__gettimeofday	gettimeofday
 personality	EXTRA	personality	Ei:i	__personality	personality
 posix_fadvise	-	fadvise64	Vi:iiii	posix_fadvise	posix_fadvise64